Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB version 4.3.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sleepycat.collections
Class StoredSortedKeySet

    java.lang.Object
      com.sleepycat.collections.StoredContainer
          com.sleepycat.collections.StoredCollection
              com.sleepycat.collections.StoredKeySet
                  com.sleepycat.collections.StoredSortedKeySet

All Implemented Interfaces:
  Cloneable, Collection, Set, SortedSet

public class StoredSortedKeySet
extends StoredKeySet
implements SortedSet

The SortedSet returned by Map.keySet() and which can also be constructed directly if a Map is not needed. Since this collection is a set it only contains one element for each key, even when duplicates are allowed. Key set iterators are therefore particularly useful for enumerating the unique keys of a store or index that allows duplicates.

Note that this class does not conform to the standard Java collections interface in the following ways:

- The `StoredContainer.size()` method always throws `UnsupportedOperationException` because, for performance reasons, databases do not maintain their total record count.
- All iterators must be explicitly closed using `StoredIterator.close()` or `StoredIterator.close(java.util.Iterator)` to release the underlying database cursor resources.

In addition to the standard SortedSet methods, this class provides the following methods for stored sorted sets only. Note that the use of these methods is not compatible with the standard Java collections interface.

- `headSet(Object, boolean)`
- `tailSet(Object, boolean)`
- `subSet(Object, boolean, Object, boolean)`

Constructor Summary
`StoredSortedKeySet(Database database, EntryBinding keyBinding, boolean writeAllowed)` Creates a sorted key set view of a `Database`.

Method Summary
`Comparator` | `comparator()` Returns null since comparators are not supported.
`Object` | `first()` Returns the first (lowest) element currently in this sorted set.
`SortedSet` | `headSet(Object toKey)` Returns a view of the portion of this sorted set whose elements are strictly less than toKey.
`SortedSet` | `headSet(Object toKey, boolean toInclusive)` Returns a view of the portion of this sorted set whose elements are strictly less than toKey, optionally including toKey.
`Object` | `last()` Returns the last (highest) element currently in this sorted set.
`SortedSet` | `subSet(Object fromKey, boolean fromInclusive, Object toKey, boolean toInclusive)` Returns a view of the portion of this sorted set whose elements are strictly greater than fromKey and strictly less than toKey, optionally including fromKey and toKey.
`SortedSet` | `subSet(Object fromKey, Object toKey)` Returns a view of the portion of this sorted set whose elements range from fromKey, inclusive, to toKey, exclusive.
`SortedSet` | `tailSet(Object fromKey)` Returns a view of the portion of this sorted set whose elements are greater than or equal to fromKey.
`SortedSet` | `tailSet(Object fromKey, boolean fromInclusive)` Returns a view of the portion of this sorted set whose elements are strictly greater than fromKey, optionally including fromKey.

Methods inherited from class com.sleepycat.collections.StoredKeySet
`add, contains, remove`

Methods inherited from class com.sleepycat.collections.StoredCollection
`addAll, containsAll, equals, hashCode, iterator, iterator, join, removeAll, retainAll, toArray, toArray, toList, toString`

Methods inherited from class com.sleepycat.collections.StoredContainer
`areDuplicatesAllowed, areDuplicatesOrdered, areKeysRenumbered, clear, isDirtyRead, isDirtyReadAllowed, isEmpty, isOrdered, isSecondary, isTransactional, isWriteAllowed, size`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Set
`add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

Constructor Detail

### StoredSortedKeySet

    public StoredSortedKeySet(Database database,
                              EntryBinding keyBinding,
                              boolean writeAllowed)

  Creates a sorted key set view of a `Database`.

Parameters:
  `database` - is the Database underlying the new collection.
  `keyBinding` - is the binding used to translate between key buffers and key objects.
  `writeAllowed` - is true to create a read-write collection or false to create a read-only collection.
Throws:
  `IllegalArgumentException` - if formats are not consistently defined or a parameter is invalid.
  `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

Method Detail

### comparator

    public Comparator comparator()

  Returns null since comparators are not supported. The natural ordering of a stored collection is data byte order, whether the data classes implement the `Comparable` interface or not. This method does not conform to the `SortedSet.comparator()` interface.

  Specified by:
    `comparator` in interface `SortedSet`
  Returns:
    null.

### first

    public Object first()

  Returns the first (lowest) element currently in this sorted set. This method conforms to the `SortedSet.first()` interface.

  Specified by:
    `first` in interface `SortedSet`
  Returns:
    the first element.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### last

    public Object last()

  Returns the last (highest) element currently in this sorted set. This method conforms to the `SortedSet.last()` interface.

  Specified by:
    `last` in interface `SortedSet`
  Returns:
    the last element.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### headSet

    public SortedSet headSet(Object toKey)

  Returns a view of the portion of this sorted set whose elements are strictly less than toKey. This method conforms to the `SortedSet.headSet(java.lang.Object)` interface.

  Specified by:
    `headSet` in interface `SortedSet`
  Parameters:
    `toKey` - is the upper bound.
  Returns:
    the subset.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### headSet

    public SortedSet headSet(Object toKey,
                             boolean toInclusive)

  Returns a view of the portion of this sorted set whose elements are strictly less than toKey, optionally including toKey. This method does not exist in the standard `SortedSet` interface.

  Parameters:
    `toKey` - is the upper bound.
    `toInclusive` - is true to include toKey.
  Returns:
    the subset.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### tailSet

    public SortedSet tailSet(Object fromKey)

  Returns a view of the portion of this sorted set whose elements are greater than or equal to fromKey. This method conforms to the `SortedSet.tailSet(java.lang.Object)` interface.

  Specified by:
    `tailSet` in interface `SortedSet`
  Parameters:
    `fromKey` - is the lower bound.
  Returns:
    the subset.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### tailSet

    public SortedSet tailSet(Object fromKey,
                             boolean fromInclusive)

  Returns a view of the portion of this sorted set whose elements are strictly greater than fromKey, optionally including fromKey. This method does not exist in the standard `SortedSet` interface.

  Parameters:
    `fromKey` - is the lower bound.
    `fromInclusive` - is true to include fromKey.
  Returns:
    the subset.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### subSet

    public SortedSet subSet(Object fromKey,
                            Object toKey)

  Returns a view of the portion of this sorted set whose elements range from fromKey, inclusive, to toKey, exclusive. This method conforms to the `SortedSet.subSet(java.lang.Object, java.lang.Object)` interface.

  Specified by:
    `subSet` in interface `SortedSet`
  Parameters:
    `fromKey` - is the lower bound.
    `toKey` - is the upper bound.
  Returns:
    the subset.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### subSet

    public SortedSet subSet(Object fromKey,
                            boolean fromInclusive,
                            Object toKey,
                            boolean toInclusive)

  Returns a view of the portion of this sorted set whose elements are strictly greater than fromKey and strictly less than toKey, optionally including fromKey and toKey. This method does not exist in the standard `SortedSet` interface.

  Parameters:
    `fromKey` - is the lower bound.
    `fromInclusive` - is true to include fromKey.
    `toKey` - is the upper bound.
    `toInclusive` - is true to include toKey.
  Returns:
    the subset.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB version 4.3.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 1996-2004 Sleepycat Software, Inc. - All rights reserved.